(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('apollo-link-core'), require('apollo-fetch'), require('graphql/language/printer')) :
	typeof define === 'function' && define.amd ? define(['exports', 'apollo-link-core', 'apollo-fetch', 'graphql/language/printer'], factory) :
	(factory((global.httpLink = {}),global.apolloLinkCore,global.apolloFetch,global.graphql_language_printer));
}(this, (function (exports,apolloLinkCore,apolloFetch,graphql_language_printer) { 'use strict';

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var HttpLink = (function (_super) {
    __extends(HttpLink, _super);
    function HttpLink(fetchParams) {
        var _this = _super.call(this) || this;
        _this.headers = {};
        _this._fetch =
            (fetchParams && fetchParams.fetch) ||
                apolloFetch.createApolloFetch({ uri: fetchParams && fetchParams.uri });
        _this._fetch.use(function (request, next) {
            request.options.headers = __assign({}, request.options.headers, _this.headers);
            next();
        });
        return _this;
    }
    HttpLink.prototype.request = function (operation) {
        var _this = this;
        this.headers = (operation.context && operation.context.headers) || {};
        var request = __assign({}, operation, { query: graphql_language_printer.print(operation.query) });
        return new apolloLinkCore.Observable(function (observer) {
            _this._fetch(request)
                .then(function (data) {
                if (!observer.closed) {
                    observer.next(data);
                    observer.complete();
                }
            })
                .catch(function (error) {
                if (!observer.closed) {
                    observer.error(error);
                }
            });
        });
    };
    return HttpLink;
}(apolloLinkCore.ApolloLink));

exports['default'] = HttpLink;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bundle.umd.js.map
